	GET	registers.s
	GET	swis.s

	AREA	|____dynamicarea_create|, CODE, READONLY
	EXPORT	dynamicarea_create
dynamicarea_create

; r0 is ^ name
; r1 is initial size
; r2 is maximum size
; returns area number, or -1 for failure

	STMFD	r13!,{r4-r8,lr}
	MOV	r5,r2
	MOV	r2,r1
	MOV	r8,r0
	MOV	r0,#0
	MOV	r1,#-1
	MOV	r3,#-1
	MOV	r4,#128
	MOV	r6,#0
	MOV	r7,#0
	SWI	XOS_DynamicArea
	MOVVS	r0,#-1
	MOVVC	r0,r1
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

	AREA	|____dynamicarea_destroy|, CODE, READONLY
	EXPORT	dynamicarea_destroy
dynamicarea_destroy

	MOV	r1,r0
	MOV	r0,#1
	SWI	XOS_DynamicArea
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____dynamicarea_extend|, CODE, READONLY
	EXPORT	dynamicarea_extend
dynamicarea_extend

; r0 is area
; r1 is new size

; returns 1 for success, or 0 for failure

	STMFD	r13!,{r4-r8,lr}
	MOV	r12,r1
	MOV	r1,r0
	MOV	r0,#2
	SWI	XOS_DynamicArea
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4-r8,pc}
 |
	LDMVSFD	r13!,{r4-r8,pc}^
 ]
	MOV	r0,r1
	SUB	r1,r12,r2
	SWI	XOS_ChangeDynamicArea
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

	AREA	|____dynamicarea_size|, CODE, READONLY
	EXPORT	dynamicarea_size
dynamicarea_size

	STMFD	r13!,{r4-r8,lr}
	MOV	r1,r0
	MOV	r0,#2
	SWI	XOS_DynamicArea
	MOVVS	r0,#-1
	MOVVC	r0,r2
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

	AREA	|____dynamicarea_address|, CODE, READONLY
	EXPORT	dynamicarea_address
dynamicarea_address

	STMFD	r13!,{r4-r8,lr}
	MOV	r1,r0
	MOV	r0,#2
	SWI	XOS_DynamicArea
	MOVVS	r0,#0
	MOVVC	r0,r3
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

	END
